<script>
  import Navbar from './Navbar.svelte'
  import { location, querystring } from 'svelte-spa-router'
  import { views } from '../../store'

  import Index from './Index.svelte'
  import ListView from './ListView.svelte'
  import FormView from './FormView.svelte'

  export let params = {} // params from url

  let currentView = null
  let currentComponent = null

  let allViews = []
  const components = {
    ListView,
    FormView,
  }

  function getView () {
    if (!$views || !$views.length) {
      return
    }

    if (params.view === undefined) {
      currentComponent = Index
      currentView = {}
      return
    }

    currentView = $views.find(v => {
      if (v.slug) {
        return v.slug.replace(/\//g, '') === params.view
      }
    })

    // order fields (should be done on server)
    if (currentView) {
      currentView.ViewFields = currentView.ViewFields.sort((a, b) => a.order - b.order)
      currentComponent = components[currentView.type]
    }
  }

  $: if (params.view) {
    getView()
  }

  views.subscribe(viewsValue => {
    getView()
  })
</script>

<main class="flex h-screen is-clipped">
  <Navbar />

  <aside class="bg-gray-200 flex-grow has-auto-scroll">
    {#if !currentView}
      <!-- Loading... -->
    {:else}
      <svelte:component this={currentComponent} view={currentView} id={params.id} />
    {/if}
  </aside>
</main>
